<?php
//no direct access
defined('_JEXEC') or die('Direct Access to this location is not allowed.');
JHTML::stylesheet('seolista.css','modules/mod_averz_seolista/css/');

if (!isset($averz_data_tmp_dir)) {
    $cache_directory = 'modules/mod_averz_seolista/averz-seo-lista';   
} else {
    $cache_directory = $averz_data_tmp_dir;
}

$local_tmp_file = $cache_directory.'/averz-seo-lista.tmp';

if (!function_exists('file_put_contents')) {
  function file_put_contents($fileName, $s)
  {
    $f = fopen($fileName, 'w');
    fwrite($f, $s);
    fclose($f);
  }
}

function get_content_from_url($url, $timeout = 3) {
    $result = "";
    $url = parse_url($url);
    if ($fs = @fsockopen ($url['host'], 80)) {
        if ( function_exists("socket_set_timeout") ) {
            socket_set_timeout($fs, $timeout, 0);
        } else if ( function_exists("stream_set_timeout") ) {
            stream_set_timeout($fs, $timeout, 0);
        }
        $http_get_cmd = "GET ".$url['path']."?".$url['query']." HTTP/1.0\r\n".
                        "Host: ".$url['host']."\r\n".
                        "Connection: Close\r\n\r\n";
        fwrite ($fs, $http_get_cmd);
        while (!feof($fs)) {
            $result .= @fread($fs, 40960);
        }
        fclose($fs);
        if (StrPos($result, "404 Not Found DATA")) {
          return false;
        } else {
          return $result;
        }
    } else {
        return false;
    }
}

function parse_averz_data_xml($xml_content) {
    preg_match_all('~<averz-seo-data>(.*?)</averz-seo-data>~si', $xml_content, $items);
    $pole = $items[1];
    if (count($pole) > 1) {
    	srand((float) microtime() * 10000000);
      $rand_keys = array_rand($pole, 2);
      return $pole[$rand_keys[0]];
    } else {
      return false;
    }  
}

if ((!file_exists($local_tmp_file) || filemtime($local_tmp_file) < (time() - 1800) || filesize($local_tmp_file) < 500 )) {
    $input_url = 'http://addons.averz.cz/seo-lista/averz-seo-lista.data';
    $tmp_content = get_content_from_url($input_url);
    if($tmp_content) {      
      file_put_contents($local_tmp_file, $tmp_content);
    } else {
      $tmp_content = file_get_contents($local_tmp_file);
      file_put_contents($local_tmp_file, $tmp_content);
    }
    echo "<div class=\"seolista\">";
    echo parse_averz_data_xml($tmp_content);  
    echo "</div>";
} else {

    if (($xml_content = file_get_contents($local_tmp_file)) == true) {
    echo "<div class=\"seolista\">";
    echo parse_averz_data_xml($xml_content);
    echo "</div>";
    }    
}
?>